## gnudatalanguage 1.1.1

=== CMakeLists.txt ===
#
# copyright : (c) 2010 Maxime Lenoir and Alain Coulais
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#

cmake_minimum_required(VERSION 3.2 FATAL_ERROR)

if (NOT EXISTS "${CMAKE_SOURCE_DIR}/src/whereami/.git" )
  message(FATAL_ERROR "The src/whereami git submodule is not initialised.\n Please run `git submodule update --init`")
endif()

# create version string based on git metadata (based on https://github.com/nocnokneo/cmake-git-versioning-example)
# in case version.hpp does not exist (it is shipped in GDL tarballs but not stored in the repo)
if (NOT EXISTS "${CMAKE_SOURCE_DIR}/src/version.hpp")
  find_package(Git REQUIRED)
  add_custom_target(version
    ${CMAKE_COMMAND} -D SRC=${CMAKE_SOURCE_DIR}/src/version.hpp.in
                     -D DST=${CMAKE_BINARY_DIR}/version.hpp
                     -D GIT_EXECUTABLE=${GIT_EXECUTABLE}
                     -P ${CMAKE_SOURCE_DIR}/CMakeModules/GenerateVersionHeader.cmake
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  )
endif()

# Set some policies to fix warnings in newer versions of cmake
# Since VERSION_GREATER_EQUAL is available only since 3.7, we use 
# VERSION_GREATER combined with VERSION_EQUAL to achieve what we want

if (CMAKE_MINOR_VERSION GREATER 12)
  if (CMAKE_VERSION VERSION_GREATER "3.12.0" OR CMAKE_VERSION VERSION_EQUAL "3.12.0")
      cmake_policy(SET CMP0075 NEW)
  endif(CMAKE_VERSION VERSION_GREATER "3.12.0" OR CMAKE_VERSION VERSION_EQUAL "3.12.0")
  if (CMAKE_VERSION VERSION_GREATER "3.13.0" OR CMAKE_VERSION VERSION_EQUAL "3.13.0")
      cmake_policy(SET CMP0077 NEW)
  endif(CMAKE_VERSION VERSION_GREATER "3.13.0" OR CMAKE_VERSION VERSION_EQUAL "3.13.0")
endif (CMAKE_MINOR_VERSION GREATER 12)

project(GDL)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_C_STANDARD 99)

# advice by Orion, mandatory for FC 28
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

enable_testing()

# cf issue 511, managing MultiArch on Debian ...
include(GNUInstallDirs)

include(CheckIncludeFile)
include(CheckIncludeFileCXX)
include(CheckLibraryExists)
include(CheckFunctionExists)
include(CheckSymbolExists)
include(CheckCSourceRuns)
include(CheckCXXSourceCompiles)
include(FindPkgConfig)
include(FindPackageHandleStandardArgs)
include(TestBigEndian)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/CMakeModules)
#### GDL is an interactive tool. Normally INTERACTIVE_GRAPHICS must be set
set(INTERACTIVE_GRAPHICS ON CACHE BOOL "GDL: Disable checking existence of a suited graphics driver in plplot. Only file output may be available, and 3D graphics may NOT work.")
### compile basic sources monolithically or not, make compilation slow
set(SPLIT_SOURCES_FILES ON CACHE BOOL "GDL: Force a single compilation for all templates, avoid symbol duplication")
#### Default cached values
set(GDLDEV OFF CACHE BOOL "GDL: Enable GDL developer mode (includes work-in-progress tests)")

set(PYTHON_MODULE OFF CACHE BOOL "GDL: Build GDL as a Python module ?")

set(X11 OFF CACHE BOOL "GDL: Enable X11 ?") 
set(X11DIR "" CACHE PATH "GDL: Specify X11 directory tree")

# Only GNU Readline since May 2020 (too complex to manage BSD Editline. See #754)
set(READLINE ON CACHE BOOL "GDL: Enable GNU Readline ?")
set(READLINEDIR "" CACHE PATH "GDL: Specify the GNU Readline directory tree")

set(GSLDIR "" CACHE PATH "GDL: Specify the GSL directory tree")

set(ZLIBDIR "" CACHE PATH "GDL: Specify the Zlib directory tree")

set(WXWIDGETS ON CACHE BOOL "GDL: Enable WxWidgets ?")
set(WXWIDGETSDIR "" CACHE PATH "GDL: Specify WxWidgets directory tree")

set(UDUNITS2 ON CACHE BOOL "GDL: Enable UDUNITS-2 ?")
set(UDUNITS2DIR "" CACHE PATH "GDL: Specify the UDUNITS-2 directory tree")

set(EIGEN3 ON CACHE BOOL "GDL: Enable Eigen3 ?")
set(EIGEN3DIR "" CACHE PATH "GDL: Specify the Eigen3 directory tree")

set(PNGLIB ON CACHE BOOL "GDL: Enable libpng ?")
set(PNGLIBDIR "" CACHE PATH "GDL: Specify the libpng directory tree")

set(GRIB ON CACHE BOOL "GDL: Enable GRIB ?")
set(GRIBDIR "" CACHE PATH "GDL: Specify the ECMWF ecCodes directory tree")

set(QHULL ON CACHE BOOL "GDL: Enable Qhull ?")
set(QHULLDIR "" CACHE PATH "GDL: Specify the QHULL directory tree")

set(GLPK ON CACHE BOOL "GDL: Enable GLPK (for function SIMPLEX) ?")
set(GLPKDIR "" CACHE PATH "GDL: Specify the GLPK directory tree")

# GraphicsMagick is a good alternative to ImageMagick, if GM OK, we don't look for IM
set(GRAPHICSMAGICK ON CACHE BOOL "GDL: Enable GraphicsMagick ?")
set(GRAPHICSMAGICKDIR "" CACHE PATH "GDL: Specify the GraphicsMagick directory tree")

set(MAGICK ON CACHE BOOL "GDL: Enable ImageMagick ?")
set(MAGICKDIR "" CACHE PATH "GDL: Specify the ImageMagick directory tree")

set(TIFF ON CACHE BOOL "GDL: Enable libtiff ?")
set(TIFFDIR "" CACHE PATH "GDL: Specify the libtiff directory tree")

if(TIFF)
    set(GEOTIFF ON CACHE BOOL "GDL: Enable libgeotiff ?")
    set(GEOTIFFDIR "" CACHE PATH "GDL: Specify the libgeotiff directory tree")
endif(TIFF)

set(NETCDF ON CACHE BOOL "GDL: Enable NetCDF ?")
set(NETCDFDIR "" CACHE PATH "GDL: Specify the netCDF directory tree")

set(HDF ON CACHE BOOL "GDL: Enable HDF ?")
set(HDFDIR "" CACHE PATH "GDL: Specify the HDF directory tree")

set(HDF5 ON CACHE BOOL "GDL: Enable HDF5 ?")
set(HDF5DIR "" CACHE PATH "GDL: Specify the HDF5 directory tree")

set(FFTW ON CACHE BOOL "GDL: Enable FFTW ?")
set(FFTWDIR "" CACHE PATH "GDL: Specify the FFTW directory tree")

set(LIBPROJ ON CACHE BOOL "GDL: Enable PROJ ?")
set(LIBPROJDIR "" CACHE PATH "GDL: Specifiy the PROJ directory tree")

set(MPI OFF CACHE BOOL "GDL: Enable MPI ?")
set(MPIDIR "" CACHE PATH "GDL: Specify the MPI (experimental) directory tree")

set(PYTHON ON CACHE BOOL "GDL: Enable Python ?")
set(PYTHONDIR "" CACHE PATH "GDL: Specify the use Python directory tree")
set(PYTHONVERSION "" CACHE STRING "GDL: Specify the Python version to use")

set(SHAPELIB ON CACHE BOOL "GDL: Enable SHAPELIB (for IDLffShape, MAP_CONTINENTS and all geographic data?)")
set(SHAPELIBDIR "" CACHE PATH "GDL: Specify the SHAPELIB directory tree")

set(EXPAT ON CACHE BOOL "GDL: Enable EXPAT (for IDLffXMLSAX)")
set(EXPATDIR "" CACHE PATH "GDL: Specify the libEXPAT-devel directory tree")

if(NOT WIN32)
  set(NCURSESDIR "" CACHE PATH "GDL: Specify the ncurses (or curses) directory tree")
endif(NOT WIN32)

set(OPENMP ON CACHE BOOL "GDL: Enable OpenMP ?")

# Third party libraries
set(JASPERDIR "" CACHE PATH "GDL: Specify the JasPer directory tree")
set(JPEGDIR "" CACHE PATH "GDL: Specify the JPEG directory tree")
set(SZIPDIR "" CACHE PATH "GDL: Specify the SZip directory tree")

set(GDL_DATA_DIR "/share/gnudatalanguage" CACHE PATH "GDL: data directory relative to CMAKE_INSTALL_PREFIX")
set(GDL_LIB_DIR "" CACHE PATH "GDL: library directory relative to CMAKE_INSTALL_PREFIX")
# check for 64-bit OS
if(${CMAKE_SIZEOF_VOID_P} EQUAL 8)
    set(HAVE_64BIT_OS 1)
endif(${CMAKE_SIZEOF_VOID_P} EQUAL 8)

# check for endianness, and set macro in case it is big.
TEST_BIG_ENDIAN(IS_BIGENDIAN)

#### check headers and libraries

# dl
check_library_exists(dl dlopen "" HAVE_DL)
if(HAVE_DL)
    set(LIBRARIES ${LIBRARIES} dl)
endif(HAVE_DL)

# malloc stats
check_function_exists(malloc_zone_statistics HAVE_MALLOC_ZONE_STATISTICS)
check_function_exists(sbrk HAVE_SBRK)
check_function_exists(mallinfo HAVE_MALLINFO)
check_function_exists(mallinfo2 HAVE_MALLINFO2)

# mallocs
check_include_file(malloc.h HAVE_MALLOC_H)
check_include_file(malloc/malloc.h HAVE_MALLOC_MALLOC_H)

# locale
check_include_file(locale.h HAVE_LOCALE_H)

# std includes..
check_include_file(stdint.h HAVE_STDINT_H)
check_include_file(stdlib.h HAVE_STDLIB_H)
check_include_file(string.h HAVE_STRING_H)
check_include_file(strings.h HAVE_STRINGS_H)
check_include_file(sys/stat.h HAVE_SYS_STAT_H)
check_include_file(sys/types.h HAVE_SYS_TYPES_H)
check_include_file(unistd.h HAVE_UNISTD_H)
#check_include_file(ext/stdio_filebuf.h HAVE_EXT_STDIO_FILEBUF_H)
#sometimes it compiles but stdio_filebuf is only in gcc-x-y-z directory tree...
# would be silly not to use this functionality if present, so recheck:
if (HAVE_EXT_STDIO_FILEBUF_H)
else (HAVE_EXT_STDIO_FILEBUF_H)
    check_cxx_source_compiles("
#include <ext/stdio_filebuf.h>
int main(int argc, char **argv) {
    int i=0;
    i+=1;
}" REALLY_HAVE_EXT_STDIO_FILEBUF_H)
endif (HAVE_EXT_STDIO_FILEBUF_H)
if (REALLY_HAVE_EXT_STDIO_FILEBUF_H)
message(STATUS "INFO: will use GNU extensions for STDIO (useful for compressed I/O) since it seems accepted by your c++ compiler.")
set (HAVE_EXT_STDIO_FILEBUF_H 1)
endif (REALLY_HAVE_EXT_STDIO_FILEBUF_H)
# dlfcn.h
check_include_file(dlfcn.h HAVE_DLFCN_H)

# inttypes.h
check_include_file(inttypes.h HAVE_INTTYPES_H)

# nexttoward
check_library_exists(m nexttoward "" HAVE_NEXTTOWARD)

# mpi
check_include_file(mpi.h HAVE_MPI_H)

# SA: whithout it compilation of antlr fails if there's a conflicting 
#     version of antlr in system-wide directories
include_directories(src)

#-------------------------------MANDATORY MODULES-------------------------------------
if (NOT WIN32)
    # Ncurses MANDATORY for readline on POSIX
    # -DNCURSESDIR=DIR
    set(CMAKE_PREFIX_PATH ${NCURSESDIR})    
    set(CURSES_NEED_NCURSES TRUE)
    find_package(Curses QUIET COMPONENTS initscr)
    mark_as_advanced(CURSES_CURSES_H_PATH CURSES_FORM_LIBRARY CURSES_HAVE_CURSES_H)
    if(CURSES_FOUND)
        set(HAVE_LIBNCURSES 1)
        set(LIBRARIES ${LIBRARIES} ${CURSES_LIBRARIES})
        include_directories(${CURSES_INCLUDE_DIR})
    else(CURSES_FOUND)
        # search for curses
        set(CURSES_NEED_NCURSES FALSE)
        find_package(Curses COMPONENTS initscr)
        set(HAVE_LIBCURSES ${CURSES_FOUND})
        if(CURSES_FOUND)
            set(LIBRARIES ${LIBRARIES} ${CURSES_LIBRARIES})
            include_directories(${CURSES_INCLUDE_DIR})
        else(CURSES_FOUND)
            message(FATAL_ERROR "(N)Curses was not found.\n"
                "Use -DNCURSESDIR=DIR to specify the curses directory tree.\n"
                "(suitable Debian/Ubuntu package: libncurses-dev)\n")
        endif(CURSES_FOUND)
    endif(CURSES_FOUND)
endif (NOT WIN32)

# -DREADLINE=ON|OFF
# -DREADLINEDIR=DIR
if(READLINE)
  set(CMAKE_PREFIX_PATH ${READLINEDIR})
  find_package(Readline QUIET)
  set(HAVE_LIBREADLINE ${READLINE_FOUND})
  if(READLINE_FOUND)
    if(NOT WIN32)
      # readline needs (n)curses (not on Windows)
      set(CMAKE_REQUIRED_LIBRARIES ${CURSES_LIBRARIES})
    endif(NOT WIN32)
    check_library_exists("${READLINE_LIBRARIES}" rl_get_screen_size "" RL_GET_SCREEN_SIZE)
    if(NOT RL_GET_SCREEN_SIZE)
      message(STATUS "WARNING: Older GNU readline without rl_get_screen_size was found.\n"
    "For resized terminals the size might not be updated correctly.\n"
    "If this is a problem please install a recent version of readline.")
    endif(NOT RL_GET_SCREEN_SIZE)
    set(LIBRARIES ${LIBRARIES} ${READLINE_LIBRARIES})
    include_directories(${READLINE_INCLUDE_DIR})
    set(CMAKE_REQUIRED_LIBRARIES)
  else(READLINE_FOUND)
    message(FATAL_ERROR "GNU readline was not found.\n"
      "Use -DREADLINE=no to explicitely disable it.\n"
      "(suitable Debian/Ubuntu package: libreadline-gplv2-dev or libreadline-dev)\n"
      "(suitable Fedora/CentOS package: readline-devel)")
  endif(READLINE_FOUND)
endif(READLINE)

# zlib MANDATORY
# -DZLIBDIR=DIR
set(CMAKE_PREFIX_PATH ${ZLIBDIR})
find_package(ZLIB QUIET)
set(HAVE_LIBZ ${ZLIB_FOUND})
if(ZLIB_FOUND)
    set(LIBRARIES ${LIBRARIES} ${ZLIB_LIBRARIES})
    include_directories(${ZLIB_INCLUDE_DIR})
else(ZLIB_FOUND)
    message(FATAL_ERROR "ZLib library is required but was not found.\n"
    "Use -DZLIBDIR=DIR to specify the zlib directory tree.\n"
        "(suitable Debian/Ubuntu package: zlib1g-dev)\n"
        "(suitable Fedora/CentOS package: zlib-devel)")
endif(ZLIB_FOUND)

# GSL MANDATORY
# -DGSLDIR=DIR
set(CMAKE_PREFIX_PATH ${GSLDIR})

=== src/CMakeLists.txt ===
set(SOURCES
CFMTLexer.cpp
FMTIn.cpp
FMTLexer.cpp
FMTOut.cpp
FMTParser.cpp
GDLInterpreter.cpp
GDLLexer.cpp
GDLParser.cpp
GDLTreeParser.cpp
datatypes.cpp
)
 
if(NOT ONE_DATAFILE)
message(STATUS "Using Splitted datatypes.cpp.")
set(SOURCES
${SOURCES}
basic_op.cpp
basic_op_new.cpp
basic_op_add.cpp
basic_op_sub.cpp
basic_op_mult.cpp
basic_op_div.cpp
default_io.cpp
ifmt.cpp
ofmt.cpp
)
endif(NOT ONE_DATAFILE)

set (SOURCES
${SOURCES}
convol.cpp #long
convol2.cpp #long
smooth.cpp   #long also
getas.cpp
datatypes_minmax.cpp
allix.cpp
arrayindex.cpp
assocdata.cpp
basegdl.cpp
basic_fun.cpp
basic_fun_cl.cpp
basic_fun_jmg.cpp
calendar.cpp
color.cpp
convert2.cpp
dcommon.cpp
dcompiler.cpp
dialog.cpp
dinterpreter.cpp
dnode.cpp
dpro.cpp
dSFMT/dSFMT.c
dstructdesc.cpp
dstructfactory.cxx
dstructgdl.cpp
dvar.cpp
eigenvalues_solvers.cpp
envt.cpp
extrat.cpp
exists_fun.cpp
fftw.cpp
file.cpp
fmtnode.cpp
gdl2gdl.cpp
gdlarray.cpp
gdleventhandler.cpp
gdlexception.cpp
gdlfpexceptions.cpp
gdlgstream.cpp
)

if(NOT WIN32)
set(SOURCES
${SOURCES}
gdlxstream.cpp
shm.cpp
)
endif(NOT WIN32)

set(SOURCES
${SOURCES}
gdljournal.cpp
gdlhelp.cpp
gdlpsstream.cpp
gdlsvgstream.cpp
gdlwidget.cpp
gdlwidgeteventhandler.cpp
gdlwxstream.cpp
gdlzstream.cpp
getfmtast.cpp
graphicsdevice.cpp
basic_pro.cpp
basic_pro_jmg.cpp
brent.cpp
grib.cpp
gsl_fun.cpp
gsl_matrix.cpp
gzstream.hpp
hash.cpp
hdf5_fun.cpp
hdf_fun.cpp
hdf_pro.cpp
histogram.cpp
image.cpp
initct.cpp
initsysvar.cpp
interpolate.cpp
interpol.cpp
io.cpp
labelregion.cpp
lapack.cpp
least_squares.cpp
libinit.cpp
libinit_ac.cpp
libinit_cl.cpp
libinit_gm.cpp
libinit_jmg.cpp
libinit_mes.cpp
libinit_ng.cpp
libinit_jp.cpp
libinit_exists.cpp
linearprogramming.cpp
list.cpp
magick_cl.cpp
math_fun.cpp
math_fun_ac.cpp
math_fun_gm.cpp
math_fun_jmg.cpp
math_fun_ng.cpp
math_utl.cpp
matrix_cholesky.cpp
matrix_invert.cpp
mpi.cpp
ncdf_att_cl.cpp
ncdf_cl.cpp
ncdf_dim_cl.cpp
ncdf_var_cl.cpp
ncdf4_group.cpp
newprognode.cpp
nullgdl.cpp
objects.cpp
overload.cpp
plotting_axis.cpp
plotting_contour.cpp
plotting_convert_coord.cpp
plotting_cursor.cpp
plotting_device.cpp
plotting_erase.cpp
plotting_image.cpp
plotting_misc.cpp
plotting_oplot.cpp
plotting_plot.cpp
plotting_plots.cpp
plotting_polyfill.cpp
plotting_shade_surf.cpp
plotting_surface.cpp
plotting_windows.cpp
plotting_xyouts.cpp
plotting.cpp
poly_2d.cpp
print.cpp
print_tree.cpp
prognode.cpp
prognode_lexpr.cpp
prognodeexpr.cpp
projections.cpp
randomgenerators.cpp
read.cpp
saverestore.cpp
semshm.cpp
sorting.cpp
sparse_matrix.cpp
str.cpp
terminfo.cpp
tiff.cxx
triangulation.cpp
typetraits.cpp
value_locate.cpp
where.cpp
widget.cpp
)
if(USE_SHAPELIB)
set(SOURCES
${SOURCES}
Shapefiles.cpp
)
endif(USE_SHAPELIB)
if(USE_EXPAT)
set (SOURCES
${SOURCES}
sax.cpp
)
endif(USE_EXPAT)
if(HAVE_QHULL)
set (SOURCES
${SOURCES}
qhull.cpp
)
endif(HAVE_QHULL)

if(WIN32)
set(SOURCES
${SOURCES}
gdl.rc
)
endif(WIN32)

if(HAVE_LIBWXWIDGETS AND WIN32)
find_file(WX_RC wx.rc HINTS ${wxWidgets_INCLUDE_DIRS} PATH_SUFFIXES wx/msw)
set(SOURCES
${SOURCES}
${WX_RC}
)
endif(HAVE_LIBWXWIDGETS AND WIN32)

#whereami
add_library(whereami STATIC ${CMAKE_SOURCE_DIR}/src/whereami/src/whereami.c)
add_subdirectory(antlr)
add_subdirectory(plplot)

include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/src/antlr ${CMAKE_BINARY_DIR}/src ${CMAKE_SOURCE_DIR}/src/whereami/src ${CMAKE_BINARY_DIR})
link_directories(${LINK_DIRECTORIES})

if(PYTHON_MODULE) #GDL.so
	add_library(gdl SHARED ${SOURCES})
	SET_TARGET_PROPERTIES(gdl PROPERTIES PREFIX "")
	SET_TARGET_PROPERTIES(gdl PROPERTIES OUTPUT_NAME GDL)
	SET_TARGET_PROPERTIES(gdl PROPERTIES NO_SONAME TRUE)
        SET_TARGET_PROPERTIES(gdl PROPERTIES SUFFIX ".so") # e.g. Mac defaults to .dylib which is not looked for by Python
else(PYTHON_MODULE) #GDL.so
	set(SOURCES ${SOURCES} gdl.cpp)
	add_executable(gdl ${SOURCES})
endif(PYTHON_MODULE)

if(USE_OPENMP)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
endif(USE_OPENMP)

add_dependencies(gdl plplot antlr whereami) # be sure that antlr is built before gdl
target_link_libraries(gdl plplot antlr whereami) # link antlr against gdl. added librt for mmap (unix only, not osx, apparently)
if (MINGW)
target_link_libraries(gdl ws2_32)
endif (MINGW)
if (NOT APPLE AND NOT OSX AND NOT MINGW)
target_link_libraries(gdl rt) # link antlr against gdl. added librt for mmap (unix only, not osx, apparently)
endif (NOT APPLE AND NOT OSX AND NOT MINGW)

target_link_libraries(gdl ${LIBRARIES})

add_definitions(-DHAVE_CONFIG_H)

# Workaround MinGW build problem: force problematic large file to be optimized to prevent string table overflow error
# see also: https://github.com/assimp/assimp/pull/2418/files
if ((MINGW) AND (CMAKE_BUILD_TYPE MATCHES Debug))
	message("-- Applying MinGW basic_op.cpp Debug Workaround")
	set_source_files_properties(basic_op.cpp PROPERTIES COMPILE_OPTIONS "-Os")
endif()

if(PYTHON_MODULE)
        find_package( PythonInterp ${PYTHONVERSION} REQUIRED )
	execute_process(COMMAND ${PYTHON_EXECUTABLE} -c
		"import site, sys; sys.stdout.write(site.PREFIXES[-1])"
			OUTPUT_VARIABLE PYTHON_PREFIX)
	file( TO_CMAKE_PATH "${PYTHON_PREFIX}" PYTHON_PREFIX)
        execute_process(COMMAND ${PYTHON_EXECUTABLE} -c
		"import site, sys; sys.stdout.write(site.getsitepackages()[-1])"
			OUTPUT_VARIABLE PYTHON_SITE_DIR)
	file( TO_CMAKE_PATH "${PYTHON_SITE_DIR}" PYTHON_SITE_DIR )
	string( REGEX REPLACE "^${PYTHON_PREFIX}/" ""
	       PYTHON_SITE_DIR "${PYTHON_SITE_DIR}")
	install(TARGETS gdl DESTINATION ${PYTHON_SITE_DIR})
else(PYTHON_MODULE)
	install(TARGETS gdl DESTINATION ${CMAKE_INSTALL_PREFIX}/bin)
	set_target_properties(gdl PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)
endif(PYTHON_MODULE)

install(DIRECTORY ${CMAKE_SOURCE_DIR}/src/pro/ DESTINATION ${CMAKE_INSTALL_PREFIX}/${GDL_DATA_DIR}/lib
	PATTERN CVS EXCLUDE
	PATTERN checks EXCLUDE
	PATTERN Makefile* EXCLUDE
	PATTERN UrgentNeed.txt EXCLUDE)

install(DIRECTORY ${CMAKE_SOURCE_DIR}/resource DESTINATION ${CMAKE_INSTALL_PREFIX}/${GDL_DATA_DIR}
	PATTERN CVS EXCLUDE
	PATTERN checks EXCLUDE
	PATTERN Makefile* EXCLUDE
	PATTERN UrgentNeed.txt EXCLUDE)

configure_file(
 	${CMAKE_SOURCE_DIR}/scripts/quick_start_GDL.sh.in
	${CMAKE_BINARY_DIR}/quick_start_GDL.sh
)

=== src/Makefile ===
# CMAKE generated file: DO NOT EDIT!
# Generated by "MSYS Makefiles" Generator, CMake Version 3.10

# Default target executed when no arguments are given to make.
default_target: all

.PHONY : default_target

# Allow only one "make -f Makefile2" at a time, but pass parallelism.
.NOTPARALLEL:


#=============================================================================
# Special targets provided by cmake.

# Disable implicit rules so canonical targets will work.
.SUFFIXES:


# Remove some rules from gmake that .SUFFIXES does not remove.
SUFFIXES =

.SUFFIXES: .hpux_make_needs_suffix_list


# Suppress display of executed commands.
$(VERBOSE).SILENT:


# A target that is always out of date.
cmake_force:

.PHONY : cmake_force

#=============================================================================
# Set environment variables for the build.

# The shell in which to execute make rules.
SHELL = /bin/sh

# The CMake executable.
CMAKE_COMMAND = /C/msys64/mingw32/bin/cmake.exe

# The command to remove a file.
RM = /C/msys64/mingw32/bin/cmake.exe -E remove -f

# Escaping for special characters.
EQUALS = =

# The top-level source directory on which CMake was run.
CMAKE_SOURCE_DIR = /C/projects/gdl

# The top-level build directory on which CMake was run.
CMAKE_BINARY_DIR = /F/github/gdlgit

#=============================================================================
# Targets provided globally by CMake.

# Special rule for the target install/local
install/local: preinstall
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Installing only the local directory..."
	/C/msys64/mingw32/bin/cmake.exe -DCMAKE_INSTALL_LOCAL_ONLY=1 -P cmake_install.cmake
.PHONY : install/local

# Special rule for the target install/local
install/local/fast: preinstall/fast
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Installing only the local directory..."
	/C/msys64/mingw32/bin/cmake.exe -DCMAKE_INSTALL_LOCAL_ONLY=1 -P cmake_install.cmake
.PHONY : install/local/fast

# Special rule for the target install
install: preinstall
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Install the project..."
	/C/msys64/mingw32/bin/cmake.exe -P cmake_install.cmake
.PHONY : install

# Special rule for the target install
install/fast: preinstall/fast
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Install the project..."
	/C/msys64/mingw32/bin/cmake.exe -P cmake_install.cmake
.PHONY : install/fast

# Special rule for the target list_install_components
list_install_components:
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Available install components are: \"Unspecified\""
.PHONY : list_install_components

# Special rule for the target list_install_components
list_install_components/fast: list_install_components

.PHONY : list_install_components/fast

# Special rule for the target install/strip
install/strip: preinstall
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Installing the project stripped..."
	/C/msys64/mingw32/bin/cmake.exe -DCMAKE_INSTALL_DO_STRIP=1 -P cmake_install.cmake
.PHONY : install/strip

# Special rule for the target install/strip
install/strip/fast: preinstall/fast
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Installing the project stripped..."
	/C/msys64/mingw32/bin/cmake.exe -DCMAKE_INSTALL_DO_STRIP=1 -P cmake_install.cmake
.PHONY : install/strip/fast

# Special rule for the target edit_cache
edit_cache:
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "No interactive CMake dialog available..."
	/C/msys64/mingw32/bin/cmake.exe -E echo "No interactive CMake dialog available."
.PHONY : edit_cache

# Special rule for the target edit_cache
edit_cache/fast: edit_cache

.PHONY : edit_cache/fast

# Special rule for the target rebuild_cache
rebuild_cache:
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Running CMake to regenerate build system..."
	/C/msys64/mingw32/bin/cmake.exe -H$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR)
.PHONY : rebuild_cache

# Special rule for the target rebuild_cache
rebuild_cache/fast: rebuild_cache

.PHONY : rebuild_cache/fast

# Special rule for the target test
test:
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Running tests..."
	/C/msys64/mingw32/bin/ctest.exe --force-new-ctest-process $(ARGS)
.PHONY : test

# Special rule for the target test
test/fast: test

.PHONY : test/fast

# The main all target
all: cmake_check_build_system
	cd /F/github/gdlgit && $(CMAKE_COMMAND) -E cmake_progress_start /F/github/gdlgit/CMakeFiles /F/github/gdlgit/src/CMakeFiles/progress.marks
	cd /F/github/gdlgit && $(MAKE) -f CMakeFiles/Makefile2 src/all
	$(CMAKE_COMMAND) -E cmake_progress_start /F/github/gdlgit/CMakeFiles 0
.PHONY : all

# The main clean target
clean:
	cd /F/github/gdlgit && $(MAKE) -f CMakeFiles/Makefile2 src/clean
.PHONY : clean

# The main clean target
clean/fast: clean

.PHONY : clean/fast

# Prepare targets for installation.
preinstall: all
	cd /F/github/gdlgit && $(MAKE) -f CMakeFiles/Makefile2 src/preinstall
.PHONY : preinstall

# Prepare targets for installation.
preinstall/fast:
	cd /F/github/gdlgit && $(MAKE) -f CMakeFiles/Makefile2 src/preinstall
.PHONY : preinstall/fast

# clear depends
depend:
	cd /F/github/gdlgit && $(CMAKE_COMMAND) -H$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR) --check-build-system CMakeFiles/Makefile.cmake 1
.PHONY : depend

# Convenience name for target.
src/CMakeFiles/gdl.dir/rule:
	cd /F/github/gdlgit && $(MAKE) -f CMakeFiles/Makefile2 src/CMakeFiles/gdl.dir/rule
.PHONY : src/CMakeFiles/gdl.dir/rule

# Convenience name for target.
gdl: src/CMakeFiles/gdl.dir/rule

.PHONY : gdl

# fast build rule for target.
gdl/fast:
	cd /F/github/gdlgit && $(MAKE) -f src/CMakeFiles/gdl.dir/build.make src/CMakeFiles/gdl.dir/build
.PHONY : gdl/fast

CFMTLexer.obj: CFMTLexer.cpp.obj

.PHONY : CFMTLexer.obj

# target to build an object file
CFMTLexer.cpp.obj:
	cd /F/github/gdlgit && $(MAKE) -f src/CMakeFiles/gdl.dir/build.make src/CMakeFiles/gdl.dir/CFMTLexer.cpp.obj
.PHONY : CFMTLexer.cpp.obj

CFMTLexer.i: CFMTLexer.cpp.i

.PHONY : CFMTLexer.i

# target to preprocess a source file
CFMTLexer.cpp.i:
	cd /F/github/gdlgit && $(MAKE) -f src/CMakeFiles/gdl.dir/build.make src/CMakeFiles/gdl.dir/CFMTLexer.cpp.i
.PHONY : CFMTLexer.cpp.i

CFMTLexer.s: CFMTLexer.cpp.s

.PHONY : CFMTLexer.s

# target to generate assembly for a file
CFMTLexer.cpp.s:
	cd /F/github/gdlgit && $(MAKE) -f src/CMakeFiles/gdl.dir/build.make src/CMakeFiles/gdl.dir/CFMTLexer.cpp.s
.PHONY : CFMTLexer.cpp.s

FMTIn.obj: FMTIn.cpp.obj

.PHONY : FMTIn.obj

# target to build an object file
FMTIn.cpp.obj:
	cd /F/github/gdlgit && $(MAKE) -f src/CMakeFiles/gdl.dir/build.make src/CMakeFiles/gdl.dir/FMTIn.cpp.obj
.PHONY : FMTIn.cpp.obj

FMTIn.i: FMTIn.cpp.i

.PHONY : FMTIn.i

# target to preprocess a source file
FMTIn.cpp.i:
	cd /F/github/gdlgit && $(MAKE) -f src/CMakeFiles/gdl.dir/build.make src/CMakeFiles/gdl.dir/FMTIn.cpp.i
.PHONY : FMTIn.cpp.i

FMTIn.s: FMTIn.cpp.s

.PHONY : FMTIn.s

# target to generate assembly for a file
FMTIn.cpp.s:
	cd /F/github/gdlgit && $(MAKE) -f src/CMakeFiles/gdl.dir/build.make src/CMakeFiles/gdl.dir/FMTIn.cpp.s
.PHONY : FMTIn.cpp.s

FMTLexer.obj: FMTLexer.cpp.obj

.PHONY : FMTLexer.obj

# target to build an object file
FMTLexer.cpp.obj:
	cd /F/github/gdlgit && $(MAKE) -f src/CMakeFiles/gdl.dir/build.make src/CMakeFiles/gdl.dir/FMTLexer.cpp.obj
.PHONY : FMTLexer.cpp.obj

FMTLexer.i: FMTLexer.cpp.i

.PHONY : FMTLexer.i

# target to preprocess a source file
FMTLexer.cpp.i:
	cd /F/github/gdlgit && $(MAKE) -f src/CMakeFiles/gdl.dir/build.make src/CMakeFiles/gdl.dir/FMTLexer.cpp.i
.PHONY : FMTLexer.cpp.i

FMTLexer.s: FMTLexer.cpp.s

.PHONY : FMTLexer.s

# target to generate assembly for a file
FMTLexer.cpp.s:
	cd /F/github/gdlgit && $(MAKE) -f src/CMakeFiles/gdl.dir/build.make src/CMakeFiles/gdl.dir/FMTLexer.cpp.s
.PHONY : FMTLexer.cpp.s

FMTOut.obj: FMTOut.cpp.obj

.PHONY : FMTOut.obj

# target to build an object file
FMTOut.cpp.obj:
	cd /F/github/gdlgit && $(MAKE) -f src/CMakeFiles/gdl.dir/build.make src/CMakeFiles/gdl.dir/FMTOut.cpp.obj
.PHONY : FMTOut.cpp.obj

FMTOut.i: FMTOut.cpp.i

.PHONY : FMTOut.i

# target to preprocess a source file
FMTOut.cpp.i:
	cd /F/github/gdlgit && $(MAKE) -f src/CMakeFiles/gdl.dir/build.make src/CMakeFiles/gdl.dir/FMTOut.cpp.i
.PHONY : FMTOut.cpp.i

FMTOut.s: FMTOut.cpp.s

.PHONY : FMTOut.s

# target to generate assembly for a file
FMTOut.cpp.s:
	cd /F/github/gdlgit && $(MAKE) -f src/CMakeFiles/gdl.dir/build.make src/CMakeFiles/gdl.dir/FMTOut.cpp.s
.PHONY : FMTOut.cpp.s

FMTParser.obj: FMTParser.cpp.obj

.PHONY : FMTParser.obj

# target to build an object file
FMTParser.cpp.obj:
	cd /F/github/gdlgit && $(MAKE) -f src/CMakeFiles/gdl.dir/build.make src/CMakeFiles/gdl.dir/FMTParser.cpp.obj
.PHONY : FMTParser.cpp.obj

FMTParser.i: FMTParser.cpp.i

.PHONY : FMTParser.i

# target to preprocess a source file
FMTParser.cpp.i:
	cd /F/github/gdlgit && $(MAKE) -f src/CMakeFiles/gdl.dir/build.make src/CMakeFiles/gdl.dir/FMTParser.cpp.i
.PHONY : FMTParser.cpp.i

FMTParser.s: FMTParser.cpp.s

.PHONY : FMTParser.s

# target to generate assembly for a file
FMTParser.cpp.s:
	cd /F/github/gdlgit && $(MAKE) -f src/CMakeFiles/gdl.dir/build.make src/CMakeFiles/gdl.dir/FMTParser.cpp.s
.PHONY : FMTParser.cpp.s

GDLInterpreter.obj: GDLInterpreter.cpp.obj

.PHONY : GDLInterpreter.obj

# target to build an object file
GDLInterpreter.cpp.obj:
	cd /F/github/gdlgit && $(MAKE) -f src/CMakeFiles/gdl.dir/build.make src/CMakeFiles/gdl.dir/GDLInterpreter.cpp.obj
.PHONY : GDLInterpreter.cpp.obj

GDLInterpreter.i: GDLInterpreter.cpp.i

.PHONY : GDLInterpreter.i

# target to preprocess a source file
GDLInterpreter.cpp.i:
	cd /F/github/gdlgit && $(MAKE) -f src/CMakeFiles/gdl.dir/build.make src/CMakeFiles/gdl.dir/GDLInterpreter.cpp.i
.PHONY : GDLInterpreter.cpp.i

GDLInterpreter.s: GDLInterpreter.cpp.s

.PHONY : GDLInterpreter.s

# target to generate assembly for a file
GDLInterpreter.cpp.s:
	cd /F/github/gdlgit && $(MAKE) -f src/CMakeFiles/gdl.dir/build.make src/CMakeFiles/gdl.dir/GDLInterpreter.cpp.s
.PHONY : GDLInterpreter.cpp.s

GDLLexer.obj: GDLLexer.cpp.obj

.PHONY : GDLLexer.obj

# target to build an object file
GDLLexer.cpp.obj:
	cd /F/github/gdlgit && $(MAKE) -f src/CMakeFiles/gdl.dir/build.make src/CMakeFiles/gdl.dir/GDLLexer.cpp.obj
.PHONY : GDLLexer.cpp.obj

GDLLexer.i: GDLLexer.cpp.i

.PHONY : GDLLexer.i

# target to preprocess a source file
GDLLexer.cpp.i:
	cd /F/github/gdlgit && $(MAKE) -f src/CMakeFiles/gdl.dir/build.make src/CMakeFiles/gdl.dir/GDLLexer.cpp.i
.PHONY : GDLLexer.cpp.i

GDLLexer.s: GDLLexer.cpp.s

.PHONY : GDLLexer.s

# target to generate assembly for a file
GDLLexer.cpp.s:
	cd /F/github/gdlgit && $(MAKE) -f src/CMakeFiles/gdl.dir/build.make src/CMakeFiles/gdl.dir/GDLLexer.cpp.s
.PHONY : GDLLexer.cpp.s

GDLParser.obj: GDLParser.cpp.obj

.PHONY : GDLParser.obj

# target to build an object file
GDLParser.cpp.obj:
	cd /F/github/gdlgit && $(MAKE) -f src/CMakeFiles/gdl.dir/build.make src/CMakeFiles/gdl.dir/GDLParser.cpp.obj
.PHONY : GDLParser.cpp.obj

GDLParser.i: GDLParser.cpp.i

.PHONY : GDLParser.i

# target to preprocess a source file
GDLParser.cpp.i:
	cd /F/github/gdlgit && $(MAKE) -f src/CMakeFiles/gdl.dir/build.make src/CMakeFiles/gdl.dir/GDLParser.cpp.i
.PHONY : GDLParser.cpp.i

GDLParser.s: GDLParser.cpp.s

.PHONY : GDLParser.s

# target to generate assembly for a file
GDLParser.cpp.s:
	cd /F/github/gdlgit && $(MAKE) -f src/CMakeFiles/gdl.dir/build.make src/CMakeFiles/gdl.dir/GDLParser.cpp.s
.PHONY : GDLParser.cpp.s

GDLTreeParser.obj: GDLTreeParser.cpp.obj

.PHONY : GDLTreeParser.obj

# target to build an object file
GDLTreeParser.cpp.obj:
	cd /F/github/gdlgit && $(MAKE) -f src/CMakeFiles/gdl.dir/build.make src/CMakeFiles/gdl.dir/GDLTreeParser.cpp.obj
.PHONY : GDLTreeParser.cpp.obj

GDLTreeParser.i: GDLTreeParser.cpp.i

.PHONY : GDLTreeParser.i

# target to preprocess a source file

=== testsuite/CMakeLists.txt ===
include(CTest)
set(CTEST_USE_LAUNCHERS 1)

set(BASE_SOURCE ${CMAKE_SOURCE_DIR})
set(BASE_BINARY ${CMAKE_BINARY_DIR})

if (GDLDEV)
  file(GLOB TESTLIST "${BASE_SOURCE}/testsuite/test_*.pro")
else()
  file(READ "${BASE_SOURCE}/testsuite/LIST" TESTLIST)
endif()

add_library(test_ce SHARED EXCLUDE_FROM_ALL libtest_ce.cpp)
add_test(test_build_libtest_ce
  "${CMAKE_COMMAND}"
  --build "${CMAKE_BINARY_DIR}"
  --config "$<CONFIG>"
  --target test_ce
)
file(COPY ${CMAKE_SOURCE_DIR}/testsuite/example.grib DESTINATION ${CMAKE_BINARY_DIR}/testsuite/)

set(GDL_BINARY ${BASE_BINARY}/src/gdl)
set(PATH_SEP ":")
if(WIN32 AND NOT CYGWIN)
  set(GDL_BINARY ${GDL_BINARY}.exe)
  set(PATH_SEP "\\;")
endif()

string(REGEX MATCHALL "test[_a-zA-Z0-9]+\\.pro" TESTS ${TESTLIST})
foreach(TEST ${TESTS})
  string(REGEX REPLACE "\\.pro$" "" TESTNAME ${TEST})
  add_test(NAME ${TEST} COMMAND ${GDL_BINARY} -quiet -e "if execute('${TESTNAME}') ne 1 then exit, status=1")
  if (${TESTNAME} EQUAL "test_call_external")
    set_tests_properties(${TEST} PROPERTIES DEPEND test_build_libtest_ce)
  endif()
endforeach(TEST TESTS)

set_tests_properties(${TESTS} PROPERTIES SKIP_RETURN_CODE 77 TIMEOUT 3600) # autoconf's setting
set_tests_properties(${TESTS} PROPERTIES ENVIRONMENT "LC_COLLATE=C;GDL_PATH=${BASE_SOURCE}/testsuite/${PATH_SEP}${BASE_SOURCE}/src/pro/;GDL_STARTUP=;IDL_STARTUP=")

=== src/plplot/CMakeLists.txt ===
# It is a fatal error if no working C compiler is available to build
# the PLplot core C library and core C examples.  All other compilers
# required by our bindings are optional in that if no working compiler
# of the kind needed is available, the associated bindings and
# examples are disabled.
enable_language(C)
message(STATUS "CMAKE_SYSTEM_NAME = ${CMAKE_SYSTEM_NAME}")
message(STATUS "CMAKE_COMMAND = ${CMAKE_COMMAND}")
message(STATUS "CMAKE_VERSION = ${CMAKE_VERSION}")
message(STATUS "CMAKE_GENERATOR = ${CMAKE_GENERATOR}")
message(STATUS "CMAKE_INCLUDE_PATH = ${CMAKE_INCLUDE_PATH}")
message(STATUS "Environment variable CMAKE_INCLUDE_PATH = $ENV{CMAKE_INCLUDE_PATH}")
message(STATUS "CMAKE_LIBRARY_PATH = ${CMAKE_LIBRARY_PATH}")
message(STATUS "Environment variable CMAKE_LIBRARY_PATH = $ENV{CMAKE_LIBRARY_PATH}")
# Location of configured language support files.
message(STATUS "CMAKE_PLATFORM_INFO_DIR = ${CMAKE_PLATFORM_INFO_DIR}")

# Locations where the gdl build system first looks for cmake modules.
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/src/plplot/modules)

#Version data that need modification for each release.
include(plplot_version)
# parameters to control overall cmake behaviour.
# Configure PLplot component variables....
include(plplot)
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/plplot_config.h.in
  ${CMAKE_CURRENT_SOURCE_DIR}/plplot_config.h
  )
# Allow access to the generated plplot_config.h for this build.
add_definitions("-DPLPLOT_HAVE_CONFIG_H")
add_subdirectory(fonts) # does not do anything until option BUILD_HERSHEY_FONTS is set to ON
add_subdirectory(include)
add_subdirectory(src)
add_subdirectory(data)
summary()

=== src/plplot/data/CMakeLists.txt ===
# data/CMakeLists.txt for PLplot
###
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2006 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

set(data_DATAFILES
  plstnd5.fnt
  plxtnd5.fnt
  cmap0_default.pal
  cmap1_default.pal
  )

install(FILES ${data_DATAFILES} DESTINATION ${CMAKE_INSTALL_PREFIX}/${GDL_DATA_DIR})

=== src/plplot/fonts/CMakeLists.txt ===
# fonts/CMakeLists.txt
# Copyright (C) 2006-2018 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

# N.B. the plhershey-unicode-gen stuff is taken care of by
# ../include/CMakeLists.txt.  This file only used to optionally build the
# Hershey fonts.

option(BUILD_HERSHEY_FONTS "Build Hershey fonts?" OFF)

if(BUILD_HERSHEY_FONTS)

  # Build Hershey fonts.

  # Create "convenience static library" to help build Hershey fonts.

  set(libhershey_SRC
    font01.c
    font02.c
    font03.c
    font04.c
    font05.c
    font06.c
    font07.c
    font08.c
    font09.c
    font10.c
    font11.c
    )

  include_directories(
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_SOURCE_DIR}/lib/qsastime
    ${CMAKE_BINARY_DIR}
    ${CMAKE_BINARY_DIR}/include
    ${CMAKE_BINARY_DIR}/lib/qsastime
    )
  add_library(hershey STATIC ${libhershey_SRC})

  add_executable(generate_stndfonts stndfont.c)

  target_link_libraries(generate_stndfonts hershey PLPLOT::plplot)

  add_executable(generate_xtndfonts xtndfont.c)

  target_link_libraries(generate_xtndfonts hershey PLPLOT::plplot)

endif(BUILD_HERSHEY_FONTS)

=== src/plplot/include/CMakeLists.txt ===
# include/CMakeLists.txt for PLplot
###
### Process this file with cmake to produce Makefile
###
# Copyright (C) 2006-2016 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
aux_source_directory(${CMAKE_CURRENT_SOURCE_DIR} PLPLOTINCLUDE)
include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/src/plplot/include)

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/plConfig.h.in
  ${CMAKE_CURRENT_SOURCE_DIR}/plConfig.h
  )

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/plDevs.h.in
  ${CMAKE_CURRENT_SOURCE_DIR}/plDevs.h
  )

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/pldll.h.in
  ${CMAKE_CURRENT_SOURCE_DIR}/pldll.h
  )

# set(plhershey-unicode-gen_SRCS
#   ${CMAKE_SOURCE_DIR}/fonts/plhershey-unicode-gen.c
#   )
# 
# if(NOT CMAKE_CROSSCOMPILING)
#   add_executable(plhershey-unicode-gen ${plhershey-unicode-gen_SRCS})
# else(NOT CMAKE_CROSSCOMPILING)
#   SET(IMPORT_EXECUTABLES ${CMAKE_NATIVE_BINARY_DIR}/include/ImportExecutables.cmake)
#   INCLUDE(${IMPORT_EXECUTABLES})
# endif(NOT CMAKE_CROSSCOMPILING)
# 
# add_custom_command(
#   OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/plhershey-unicode.h
#   COMMAND plhershey-unicode-gen
#   ${CMAKE_SOURCE_DIR}/fonts/plhershey-unicode.csv
#   ${CMAKE_CURRENT_BINARY_DIR}/plhershey-unicode.h
#   DEPENDS
#   plhershey-unicode-gen
#   ${CMAKE_SOURCE_DIR}/fonts/plhershey-unicode.csv
#   )
# 
# if(NOT CMAKE_CROSSCOMPILING)
#   export(TARGETS plhershey-unicode-gen FILE ${CMAKE_CURRENT_BINARY_DIR}/ImportExecutables.cmake )
# endif(NOT CMAKE_CROSSCOMPILING)
# 
# # For cross-directory dependencies....
# add_custom_target(
#   plhershey-unicode.h_built
#   DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/plhershey-unicode.h
#   )
# 
# set(include_INSTALLED_HEADERS
#   disptab.h
#   drivers.h
#   pdf.h
#   pldebug.h
##   ${CMAKE_CURRENT_BINARY_DIR}/pldll.h
#   plevent.h
#   plplot.h
#   plplotP.h
#   plstrm.h
#   plxwd.h
##   ${CMAKE_CURRENT_BINARY_DIR}/plConfig.h
##   ${CMAKE_CURRENT_BINARY_DIR}/plDevs.h
#   )
# 
# install(FILES ${include_INSTALLED_HEADERS} DESTINATION  ${CMAKE_CURRENT_BINARY_DIR})
#

=== src/plplot/src/CMakeLists.txt ===
# src/CMakeLists.txt for PLplot
# Copyright (C) 2006-2019 Alan W. Irwin
#
# This file is part of PLplot.
#
# PLplot is free software; you can redistribute it and/or modify
# it under the terms of the GNU Library General Public License as published
# by the Free Software Foundation; version 2 of the License.
#
# PLplot is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU Library General Public License
# along with PLplot; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA

set(plplot_LIB_SRCS
  pdfutils.c
  plmem.c
  plaffine.c
  plarc.c
  plargs.c
  plbox.c
  plcont.c
  plcore.c
  plctrl.c
  plcvt.c
  pldtik.c
  plf2ops.c
  plfill.c
  plfreetype.c
  plgradient.c
  plhist.c
  plimage.c
  plline.c
  plmetafile.c
  plot3d.c
  plpage.c
  plsdef.c
  plshade.c
  plstdio.c
  plstripc.c
  plsym.c
  pltick.c
  plvpor.c
  plwind.c
  plbuf.c
  plgridd.c
  plvect.c
#  mt19937ar.c
#  pltime.c
  pllegend.c
# added
  plstream.cc
  )

option(HERSHEY_FALLBACK "Hershey fallback for Unicode fonts" ON)

if(NOT HERSHEY_FALLBACK)
  get_source_file_property(PLSYM_COMPILE_PROPS plsym.c COMPILE_FLAGS)
  if(NOT PLSYM_COMPILE_PROPS)
    set(PLSYM_COMPILE_PROPS)
  endif(NOT PLSYM_COMPILE_PROPS)
  set_source_files_properties(
    plsym.c
    PROPERTIES COMPILE_FLAGS "${PLSYM_COMPILE_PROPS} -DPL_TEST_FOR_MISSING_GLYPHS"
    )
endif(NOT HERSHEY_FALLBACK)

set(pc_libplplot_COMPILE_FLAGS)

get_source_file_property(PLCORE_COMPILE_PROPS plcore.c COMPILE_FLAGS)
# Deal with NOTFOUND case.
if(NOT PLCORE_COMPILE_PROPS)
  set(PLCORE_COMPILE_PROPS)
endif(NOT PLCORE_COMPILE_PROPS)
if(WIN32_OR_CYGWIN)
  set(PLCORE_COMPILE_PROPS "${PLCORE_COMPILE_PROPS} -DIGNORECASE")
endif(WIN32_OR_CYGWIN)

set_source_files_properties(
  plcore.c
  PROPERTIES COMPILE_FLAGS "${PLCORE_COMPILE_PROPS}"
  )


  # Nondynamic device drivers must be included in the core PLplot library.
  set(DRIVERS_RPATH)

    message("DRIVERS_LIST = ${DRIVERS_LIST}")
  foreach(SOURCE_ROOT_NAME ${DRIVERS_LIST})
    message("${SOURCE_ROOT_NAME}_SOURCE = ${${SOURCE_ROOT_NAME}_SOURCE}")
    
    list(APPEND plplot_LIB_SRCS ${${SOURCE_ROOT_NAME}_SOURCE})
    if(${SOURCE_ROOT_NAME}_COMPILE_FLAGS)
      set_source_files_properties(
	${${SOURCE_ROOT_NAME}_SOURCE}
	PROPERTIES COMPILE_FLAGS ${${SOURCE_ROOT_NAME}_COMPILE_FLAGS}
	)
    
    list(APPEND pc_libplplot_COMPILE_FLAGS ${${SOURCE_ROOT_NAME}_COMPILE_FLAGS})

    endif(${SOURCE_ROOT_NAME}_COMPILE_FLAGS)
    if(${SOURCE_ROOT_NAME}_RPATH)
      # Accumulate driver rpath information into DRIVERS_RPATH.
      list(APPEND DRIVERS_RPATH ${${SOURCE_ROOT_NAME}_RPATH})
    endif(${SOURCE_ROOT_NAME}_RPATH)
  endforeach(SOURCE_ROOT_NAME ${DRIVERS_LIST})

include_directories(
  ${CMAKE_SOURCE_DIR}/include
  ${CMAKE_SOURCE_DIR}/drivers
  ${CMAKE_BINARY_DIR}
  )

# The plplot library depends on the "lib subdirectory" libraries such
# as csironn, csirocsa, qsastime, and (possibly) nistcd.
set(LIB_INSTALL_RPATH ${LIB_DIR})
set(libplplot_LINK_LIBRARIES)

  list(APPEND libplplot_LINK_LIBRARIES ${DRIVERS_LINK_FLAGS})
  # For this case the plplot library depends on external libraries required
  # by the device driver code that is in the plplot library.
  list(APPEND LIB_INSTALL_RPATH ${DRIVERS_RPATH})

message("DEBUG: LIB_INSTALL_RPATH = ${LIB_INSTALL_RPATH}")

if(MATH_LIB)
  list(APPEND libplplot_LINK_LIBRARIES ${MATH_LIB})
endif(MATH_LIB)

if(WITH_FREETYPE)
  get_source_file_property(PLFREETYPE_COMPILE_PROPS plfreetype.c COMPILE_FLAGS)
  # Deal with NOTFOUND case.
  if(NOT PLFREETYPE_COMPILE_PROPS)
    set(PLFREETYPE_COMPILE_PROPS)
  endif(NOT PLFREETYPE_COMPILE_PROPS)
  set_source_files_properties(plfreetype.c PROPERTIES COMPILE_FLAGS "${PLFREETYPE_COMPILE_PROPS} ${FREETYPE_INCLUDE_CFLAGS}")
  list(APPEND libplplot_LINK_LIBRARIES ${FREETYPE_LIBRARIES})
endif(WITH_FREETYPE)

# Copy current information in libplplot_LINK_LIBRARIES
# into pc_libplplot_LINK_FLAGS, which contains the equivalent list information
# in a combination of library list form and pkg-config form that will
# eventually be transformted into pure pkg-config form.  Both variables
# will have data added to them afterward due to the internal PLplot libraries
# which have a different pkg-config treatment than the external libraries
# dealt with here.
set(pc_libplplot_LINK_FLAGS ${libplplot_LINK_LIBRARIES})


# The above completes dealing with the external libraries.  Now
# deal with the internal libraries that are built by the PLplot
# build system.

if(PLD_wxwidgets AND RT_LIB)
  list(APPEND libplplot_LINK_LIBRARIES ${RT_LIB})
  list(APPEND pc_libplplot_LINK_FLAGS ${RT_LIB})
endif(PLD_wxwidgets AND RT_LIB)

message(STATUS "libplplot_LINK_LIBRARIES = ${libplplot_LINK_LIBRARIES}")

#configure_library_build(plplot "" "${plplot_LIB_SRCS}" "${libplplot_LINK_LIBRARIES}" "${LIB_INSTALL_RPATH}")
#add_dependencies(${WRITEABLE_TARGET}plplot plhershey-unicode.h_built)

message("pc_libplplot_LINK_FLAGS = ${pc_libplplot_LINK_FLAGS}")

string(REGEX REPLACE ";" " "
  pc_libplplot_COMPILE_FLAGS
  "${pc_libplplot_COMPILE_FLAGS}"
  )
message("pc_libplplot_COMPILE_FLAGS = ${pc_libplplot_COMPILE_FLAGS}")

#aux_source_directory(${CMAKE_CURRENT_SOURCE_DIR} PLPLOTSOURCES)
include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/src/plplot ${CMAKE_SOURCE_DIR}/src/plplot/include)

if(PYTHON_MODULE)
	add_library(plplot SHARED ${plplot_LIB_SRCS})
	install(TARGETS plplot DESTINATION ${CMAKE_INSTALL_PREFIX}/lib)
else(PYTHON_MODULE)
	add_library(plplot STATIC ${plplot_LIB_SRCS})
endif(PYTHON_MODULE)

=== debian/changelog ===
gnudatalanguage (1.1.1-3) unstable; urgency=medium

  [ Phil Wyett ]
  * Remove 'Files-Excluded' entries, as they do not exist in upstream today.
  * Convert 'd/watch' to version 5 format.
  * Remove no longer needed 'Rules-Requires-Root: no'. Now is default behavior.

  [ Ole Streicher ]
  * Push CMake minversion to 3.16 (Closes: #1112969)

 -- Ole Streicher <olebole@debian.org>  Fri, 26 Sep 2025 18:39:09 +0200

gnudatalanguage (1.1.1-2) unstable; urgency=medium

  [ Bas Couwenberg ]
  * Replace libhdf4-alt-dev with libhdf4-dev. (closes: #1108647)
  * Disable Salsa CI i386 build.
  * Use dh-sequence-* build dependencies.

  [ Ole Streicher ]
  * Fix "Eprint" attribute name in d/u/metadata and remove "Name" attribute
  * Pust Standards-Version to 4.7.2. No changes needed
  * d/copyright: Remove unused license 4-line-bsdish

 -- Ole Streicher <olebole@debian.org>  Wed, 13 Aug 2025 10:31:24 +0200

gnudatalanguage (1.1.1-1) unstable; urgency=medium

  * New upstream version.
  * d/clean: updated.
  * d/copyright: updated.

 -- Alex Myczko <tar@debian.org>  Wed, 19 Feb 2025 17:27:02 +0000

=== debian/control ===
Source: gnudatalanguage
Maintainer: Debian Astronomy Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Ole Streicher <olebole@debian.org>,
           Alex Myczko <tar@debian.org>
Section: interpreters
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-python,
               dh-sequence-numpy3,
               dh-sequence-python3,
               hdf5-tools,
               libantlr-dev,
               libeigen3-dev,
               libfftw3-dev,
               libgeotiff-dev,
               libgraphicsmagick++1-dev,
               libeccodes-dev,
               libgsl-dev,
               libhdf4-dev,
               libhdf5-dev,
               libproj-dev,
               libglpk-dev,
               libncurses-dev,
               libnetcdf-dev,
               libqhull-dev,
               libreadline-dev,
               libshp-dev,
               libtirpc-dev,
               libudunits2-dev,
               libwhereami-dev,
               libwxgtk3.2-dev,
               pslib-dev,
               python3-dev,
               python3-numpy,
               xauth,
               xvfb,
               zlib1g-dev
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian-astro-team/gnudatalanguage
Vcs-Git: https://salsa.debian.org/debian-astro-team/gnudatalanguage.git
Homepage: https://github.com/gnudatalanguage/gdl

Package: libgnudatalanguage0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Free IDL compatible incremental compiler shared library
 GNU Data Language (GDL) is a free IDL (Interactive Data Language)
 compatible incremental compiler. It has full syntax compatibility
 with IDL 7.1. IDL is a registered trademark of ITT Visual Information
 Solutions.
 .
 This package contains the shared library which is used by the different
 frontends (gdl binary, Python package).

Package: gnudatalanguage
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: python3-numpy
Description: Free IDL compatible incremental compiler
 GNU Data Language (GDL) is a free IDL (Interactive Data Language)
 compatible incremental compiler. It has full syntax compatibility
 with IDL 7.1. IDL is a registered trademark of ITT Visual Information
 Solutions. From IDL 8.0, the following language elements are
 supported:
 .
  * FOREACH loop
  * negative array indices
  * garbage collection pointers and objects
  * call methods on an object using "." (e. g. `object.aMemberProcedure,arg1`)
 .
 The file input output system is fully implemented. GUI support (widgets) is
 officially provided, but it's not complete yet.
 .
 This package contains the main commandline and interpreter frontend.

Package: python3-gdl
Architecture: any
Multi-Arch: same
Section: python
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Provides: ${python3:Provides}
Description: Python interface for the GNU Data Language
 GNU Data Language (GDL) is a free IDL (Interactive Data Language)
 compatible incremental compiler. It has full syntax compatibility
 with IDL 7.1. IDL is a registered trademark of ITT Visual Information
 Solutions. From IDL 8.0, the following language elements are
 supported:
 .
  * FOREACH loop
  * negative array indices
  * garbage collection pointers and objects
  * call methods on an object using "." (e. g. `object.aMemberProcedure,arg1`)
 .
 The file input output system is fully implemented. GUI support (widgets) is
 officially provided, but it's not complete yet.
 .
 This package contains the Python library/interface.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

CXXFLAGS += -DBUILD_DATE="\"$(shell LC_ALL=C date -u --date=@"$(SOURCE_DATE_EPOCH)" +'%b %e %Y')\"" -std=gnu++11

# Lift the usual restrictions on the size of the global offset table.
# Taken from the gcc manpage
# earlier taken from https://bugs.debian.org/895214 (less debug info
# to avoid running out of address space)
ifneq (,$(filter $(DEB_HOST_ARCH), mips mipsel))
  export CXXFLAGS += -mxgot
endif

# Workaround for
# https://github.com/gnudatalanguage/gdl/issues/677
LDFLAGS += -Wl,--allow-multiple-definition

%:
	dh $@ -Scmake

override_dh_auto_configure:
	dh_auto_configure -- \
	  -DDEB_BUILD_MULTIARCH=`dpkg-architecture -qDEB_BUILD_MULTIARCH` \
	  -DFFTW=YES \
	  -DLIBPROJ4=YES \
	  -DGLPK=YES \
	  -DPYTHON=YES \
	  -DPYTHONVERSION=3 \
	  -DPYTHON_MODULE=YES \
	  -DWXWIDGETS=YES \
	  -DGRIB=YES \
	  -DQHULL=NO \
	  -DUDUNITS=YES \
	  -DPSLIB=YES \
	  -DGDL_LIB_DIR=/usr/lib/`dpkg-architecture -qDEB_BUILD_MULTIARCH`/gnudatalanguage

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	( cd obj*/testsuite \
	&& $(CXX) $(CXXFLAGS) $(CPPFLAGS) $(LDFLAGS) -o libtest_ce.so ../../testsuite/libtest_ce.cpp -shared -fPIC )
	LD_LIBRARY_PATH="../src" xvfb-run dh_auto_test --no-parallel -Scmake || true
endif


override_dh_compress:
	dh_compress -X.pro

=== debian/tests/control ===
Tests: test-gdl
Depends: gnudatalanguage, xauth, xvfb, hdf5-tools
Restrictions: allow-stderr, flaky

Tests: test-GDL.py
Depends: python3-gdl, python3-pytest, python3-numpy

=== debian/watch ===
Version: 5
Template: Github
Owner: gnudatalanguage
Project: gdl
